//@ts-nocheck
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
"use strict";exports.validateBooking = validate21;const schema6 = {"title":"Booking","description":"A booking in the booking system.","type":"object","required":["ID","Time","Devices","Status","You","External"],"properties":{"ID":{"type":"string","format":"uri","description":"Unique ID of the booking."},"Time":{"$ref":"#/components/schemas/Timeslot"},"Devices":{"type":"array","items":{"type":"string","format":"uri"}},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]},"Status":{"description":"Current status of the booking. While the booking is pending, it can not be used. Will change automatically and can not be set by user. 'rejected' is set when the initial booking failed, 'cancelled' when the booking was deleted / cancelled after it was once active. The 'active-*' will be used when a device was added after the booking was locked.","type":"string","enum":["pending","booked","rejected","cancelled","active","active-pending","active-rejected"]},"You":{"type":"boolean","description":"If true, this booking was done by you."},"External":{"type":"boolean","description":"Shows whether the booking was done by an external institution."},"Message":{"type":"string","description":"User readable notes about the status of the booking (e.g. if devices are unknown)."}},"x-standalone":true,"x-name":"Booking","x-location":"#/components/schemas/Booking","x-schema-type":"all"};const formats0 = require("ajv-formats/dist/formats").fullFormats.uri;const schema7 = {"title":"Timeslot","description":"A time slot represents a slice of time used for bookings.","type":"object","required":["Start","End"],"properties":{"Start":{"type":"string","description":"Start time of the booking.","format":"date-time"},"End":{"type":"string","description":"End time of the booking.","format":"date-time"}},"x-standalone":true,"x-name":"Timeslot","x-location":"#/components/schemas/Timeslot","x-schema-type":"all"};const formats2 = require("ajv-formats/dist/formats").fullFormats["date-time"];function validate22(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Start === undefined) && (missing0 = "Start")) || ((data.End === undefined) && (missing0 = "End"))){validate22.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema7.required,parentSchema:schema7,data}];return false;}else {if(data.Start !== undefined){let data0 = data.Start;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats2.validate(data0))){validate22.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema7.properties.Start,data:data0}];return false;}}else {validate22.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema7.properties.Start.type,parentSchema:schema7.properties.Start,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.End !== undefined){let data1 = data.End;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats2.validate(data1))){validate22.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema7.properties.End,data:data1}];return false;}}else {validate22.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema7.properties.End.type,parentSchema:schema7.properties.End,data:data1}];return false;}}}var valid0 = _errs3 === errors;}else {var valid0 = true;}}}}else {validate22.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema7.type,parentSchema:schema7,data}];return false;}}validate22.errors = vErrors;return errors === 0;}function validate21(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((((((data.ID === undefined) && (missing0 = "ID")) || ((data.Time === undefined) && (missing0 = "Time"))) || ((data.Devices === undefined) && (missing0 = "Devices"))) || ((data.Status === undefined) && (missing0 = "Status"))) || ((data.You === undefined) && (missing0 = "You"))) || ((data.External === undefined) && (missing0 = "External"))){validate21.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema6.required,parentSchema:schema6,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate21.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema6.properties.ID,data:data0}];return false;}}else {validate21.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.ID.type,parentSchema:schema6.properties.ID,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs3 = errors;if(!(validate22(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);errors = vErrors.length;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.Devices !== undefined){let data2 = data.Devices;const _errs4 = errors;if(errors === _errs4){if(Array.isArray(data2)){var valid1 = true;const len0 = data2.length;for(let i0=0; i0<len0; i0++){let data3 = data2[i0];const _errs6 = errors;if(errors === _errs6){if(errors === _errs6){if(typeof data3 === "string"){if(!(formats0(data3))){validate21.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema6.properties.Devices.items,data:data3}];return false;}}else {validate21.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Devices.items.type,parentSchema:schema6.properties.Devices.items,data:data3}];return false;}}}var valid1 = _errs6 === errors;if(!valid1){break;}}}else {validate21.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema6.properties.Devices.type,parentSchema:schema6.properties.Devices,data:data2}];return false;}}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data4 = data.Type;const _errs8 = errors;if(typeof data4 !== "string"){validate21.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Type.type,parentSchema:schema6.properties.Type,data:data4}];return false;}if(!(data4 === "normal")){validate21.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema6.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema6.properties.Type.enum,parentSchema:schema6.properties.Type,data:data4}];return false;}var valid0 = _errs8 === errors;}else {var valid0 = true;}if(valid0){if(data.Status !== undefined){let data5 = data.Status;const _errs10 = errors;if(typeof data5 !== "string"){validate21.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Status.type,parentSchema:schema6.properties.Status,data:data5}];return false;}if(!(((((((data5 === "pending") || (data5 === "booked")) || (data5 === "rejected")) || (data5 === "cancelled")) || (data5 === "active")) || (data5 === "active-pending")) || (data5 === "active-rejected"))){validate21.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/enum",keyword:"enum",params:{allowedValues: schema6.properties.Status.enum},message:"must be equal to one of the allowed values",schema:schema6.properties.Status.enum,parentSchema:schema6.properties.Status,data:data5}];return false;}var valid0 = _errs10 === errors;}else {var valid0 = true;}if(valid0){if(data.You !== undefined){let data6 = data.You;const _errs12 = errors;if(typeof data6 !== "boolean"){validate21.errors = [{instancePath:instancePath+"/You",schemaPath:"#/properties/You/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema6.properties.You.type,parentSchema:schema6.properties.You,data:data6}];return false;}var valid0 = _errs12 === errors;}else {var valid0 = true;}if(valid0){if(data.External !== undefined){let data7 = data.External;const _errs14 = errors;if(typeof data7 !== "boolean"){validate21.errors = [{instancePath:instancePath+"/External",schemaPath:"#/properties/External/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema6.properties.External.type,parentSchema:schema6.properties.External,data:data7}];return false;}var valid0 = _errs14 === errors;}else {var valid0 = true;}if(valid0){if(data.Message !== undefined){let data8 = data.Message;const _errs16 = errors;if(typeof data8 !== "string"){validate21.errors = [{instancePath:instancePath+"/Message",schemaPath:"#/properties/Message/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema6.properties.Message.type,parentSchema:schema6.properties.Message,data:data8}];return false;}var valid0 = _errs16 === errors;}else {var valid0 = true;}}}}}}}}}}else {validate21.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema6.type,parentSchema:schema6,data}];return false;}}validate21.errors = vErrors;return errors === 0;}exports.validateDevice = validate24;const schema8 = {"title":"Device","description":"A device might either be a physical/virtual device or a group of device.","type":"object","required":["ID"],"properties":{"ID":{"type":"string","description":"Unique ID of the device. Contains the institution (by having an end point at that institution)","format":"uri"}},"x-standalone":true,"x-name":"Device","x-location":"#/components/schemas/Device","x-schema-type":"all"};function validate24(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.ID === undefined) && (missing0 = "ID")){validate24.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema8.required,parentSchema:schema8,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate24.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema8.properties.ID,data:data0}];return false;}}else {validate24.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema8.properties.ID.type,parentSchema:schema8.properties.ID,data:data0}];return false;}}}}}}else {validate24.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema8.type,parentSchema:schema8,data}];return false;}}validate24.errors = vErrors;return errors === 0;}exports.validateExperiment = validate25;const schema9 = {"title":"Experiment","description":"An experiment describes a set of devices and how they should be connected (potentially among other metadata).","type":"object","required":["Devices"],"properties":{"Devices":{"type":"array","description":"List of devices used in experiment.","items":{"$ref":"#/components/schemas/Device"}},"Description":{"type":"string","description":"User provided description, for example might be a reason for the booking (e.g. maintenance) or a link to the experiment. Might be empty or missing."}},"x-standalone":true,"x-name":"Experiment","x-location":"#/components/schemas/Experiment","x-schema-type":"all"};function validate25(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.Devices === undefined) && (missing0 = "Devices")){validate25.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema9.required,parentSchema:schema9,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate24(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate24.errors : vErrors.concat(validate24.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate25.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema9.properties.Devices.type,parentSchema:schema9.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Description !== undefined){let data2 = data.Description;const _errs4 = errors;if(typeof data2 !== "string"){validate25.errors = [{instancePath:instancePath+"/Description",schemaPath:"#/properties/Description/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema9.properties.Description.type,parentSchema:schema9.properties.Description,data:data2}];return false;}var valid0 = _errs4 === errors;}else {var valid0 = true;}}}}else {validate25.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema9.type,parentSchema:schema9,data}];return false;}}validate25.errors = vErrors;return errors === 0;}exports.validateTimeslot = validate22;exports.validateID = validate27;const schema10 = {"type":"string","x-standalone":false,"x-name":"ID","x-location":"#/components/parameters/ID/schema","x-schema-type":"all"};function validate27(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate27.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema10.type,parentSchema:schema10,data}];return false;}validate27.errors = vErrors;return errors === 0;}exports.validateScheduleBody = validate28;const schema11 = {"type":"object","required":["Experiment","Time"],"properties":{"Experiment":{"$ref":"#/components/schemas/Experiment"},"Time":{"$ref":"#/components/schemas/Timeslot"},"Combined":{"type":"boolean","description":"If true, show only one timetable per device instead of one for all available physical devices."},"onlyOwn":{"type":"boolean","description":"(private) Show only devices of this institution. Give an error if a device of an other institution is requested."}},"x-standalone":false,"x-name":"scheduleBody","x-location":"#/paths//schedule/post/requestBody/content/application/json/schema","x-schema-type":"all"};function validate28(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Experiment === undefined) && (missing0 = "Experiment")) || ((data.Time === undefined) && (missing0 = "Time"))){validate28.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema11.required,parentSchema:schema11,data}];return false;}else {if(data.Experiment !== undefined){const _errs1 = errors;if(!(validate25(data.Experiment, {instancePath:instancePath+"/Experiment",parentData:data,parentDataProperty:"Experiment",rootData}))){vErrors = vErrors === null ? validate25.errors : vErrors.concat(validate25.errors);errors = vErrors.length;}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs2 = errors;if(!(validate22(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);errors = vErrors.length;}var valid0 = _errs2 === errors;}else {var valid0 = true;}if(valid0){if(data.Combined !== undefined){let data2 = data.Combined;const _errs3 = errors;if(typeof data2 !== "boolean"){validate28.errors = [{instancePath:instancePath+"/Combined",schemaPath:"#/properties/Combined/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema11.properties.Combined.type,parentSchema:schema11.properties.Combined,data:data2}];return false;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.onlyOwn !== undefined){let data3 = data.onlyOwn;const _errs5 = errors;if(typeof data3 !== "boolean"){validate28.errors = [{instancePath:instancePath+"/onlyOwn",schemaPath:"#/properties/onlyOwn/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema11.properties.onlyOwn.type,parentSchema:schema11.properties.onlyOwn,data:data3}];return false;}var valid0 = _errs5 === errors;}else {var valid0 = true;}}}}}}else {validate28.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema11.type,parentSchema:schema11,data}];return false;}}validate28.errors = vErrors;return errors === 0;}exports.validateScheduleResponse200 = validate31;const schema12 = {"type":"array","items":{"type":"object","required":["Device","Booked","Free"],"properties":{"Device":{"type":"string","description":"ID of the device (or * if combined)."},"Booked":{"type":"array","description":"Array of booked times.","items":{"$ref":"#/components/schemas/Timeslot"}},"Free":{"type":"array","description":"Array of free times.","items":{"$ref":"#/components/schemas/Timeslot"}}}},"x-standalone":false,"x-name":"scheduleResponse200","x-location":"#/paths//schedule/post/responses/200/content/application/json/schema","x-schema-type":"all"};function validate31(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(Array.isArray(data)){var valid0 = true;const len0 = data.length;for(let i0=0; i0<len0; i0++){let data0 = data[i0];const _errs1 = errors;if(errors === _errs1){if(data0 && typeof data0 == "object" && !Array.isArray(data0)){let missing0;if((((data0.Device === undefined) && (missing0 = "Device")) || ((data0.Booked === undefined) && (missing0 = "Booked"))) || ((data0.Free === undefined) && (missing0 = "Free"))){validate31.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema12.items.required,parentSchema:schema12.items,data:data0}];return false;}else {if(data0.Device !== undefined){let data1 = data0.Device;const _errs3 = errors;if(typeof data1 !== "string"){validate31.errors = [{instancePath:instancePath+"/" + i0+"/Device",schemaPath:"#/items/properties/Device/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema12.items.properties.Device.type,parentSchema:schema12.items.properties.Device,data:data1}];return false;}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data0.Booked !== undefined){let data2 = data0.Booked;const _errs5 = errors;if(errors === _errs5){if(Array.isArray(data2)){var valid2 = true;const len1 = data2.length;for(let i1=0; i1<len1; i1++){const _errs7 = errors;if(!(validate22(data2[i1], {instancePath:instancePath+"/" + i0+"/Booked/" + i1,parentData:data2,parentDataProperty:i1,rootData}))){vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);errors = vErrors.length;}var valid2 = _errs7 === errors;if(!valid2){break;}}}else {validate31.errors = [{instancePath:instancePath+"/" + i0+"/Booked",schemaPath:"#/items/properties/Booked/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema12.items.properties.Booked.type,parentSchema:schema12.items.properties.Booked,data:data2}];return false;}}var valid1 = _errs5 === errors;}else {var valid1 = true;}if(valid1){if(data0.Free !== undefined){let data4 = data0.Free;const _errs8 = errors;if(errors === _errs8){if(Array.isArray(data4)){var valid3 = true;const len2 = data4.length;for(let i2=0; i2<len2; i2++){const _errs10 = errors;if(!(validate22(data4[i2], {instancePath:instancePath+"/" + i0+"/Free/" + i2,parentData:data4,parentDataProperty:i2,rootData}))){vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);errors = vErrors.length;}var valid3 = _errs10 === errors;if(!valid3){break;}}}else {validate31.errors = [{instancePath:instancePath+"/" + i0+"/Free",schemaPath:"#/items/properties/Free/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema12.items.properties.Free.type,parentSchema:schema12.items.properties.Free,data:data4}];return false;}}var valid1 = _errs8 === errors;}else {var valid1 = true;}}}}}else {validate31.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema12.items.type,parentSchema:schema12.items,data:data0}];return false;}}var valid0 = _errs1 === errors;if(!valid0){break;}}}else {validate31.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema12.type,parentSchema:schema12,data}];return false;}}validate31.errors = vErrors;return errors === 0;}exports.validateScheduleResponse404 = validate34;const schema13 = {"type":"string","description":"First unknown device ID.","x-standalone":false,"x-name":"scheduleResponse404","x-location":"#/paths//schedule/post/responses/404/content/application/json/schema","x-schema-type":"all"};function validate34(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate34.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema13.type,parentSchema:schema13,data}];return false;}validate34.errors = vErrors;return errors === 0;}exports.validateScheduleResponse422 = validate35;const schema14 = {"type":"string","description":"First virtual device ID.","x-standalone":false,"x-name":"scheduleResponse422","x-location":"#/paths//schedule/post/responses/422/content/application/json/schema","x-schema-type":"all"};function validate35(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate35.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema14.type,parentSchema:schema14,data}];return false;}validate35.errors = vErrors;return errors === 0;}exports.validateScheduleResponse500 = validate36;const schema15 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"scheduleResponse500","x-location":"#/paths//schedule/post/responses/500/content/application/json/schema","x-schema-type":"all"};function validate36(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate36.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema15.type,parentSchema:schema15,data}];return false;}validate36.errors = vErrors;return errors === 0;}exports.validateNewBookingBody = validate37;const schema16 = {"type":"object","required":["Devices","Time"],"properties":{"Devices":{"type":"array","description":"List of devices which should be added.","items":{"$ref":"#/components/schemas/Device"}},"Time":{"$ref":"#/components/schemas/Timeslot"},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]}},"x-standalone":false,"x-name":"newBookingBody","x-location":"#/paths//booking/post/requestBody/content/application/json/schema","x-schema-type":"all"};function validate37(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Devices === undefined) && (missing0 = "Devices")) || ((data.Time === undefined) && (missing0 = "Time"))){validate37.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema16.required,parentSchema:schema16,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate24(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate24.errors : vErrors.concat(validate24.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate37.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema16.properties.Devices.type,parentSchema:schema16.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs4 = errors;if(!(validate22(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate22.errors : vErrors.concat(validate22.errors);errors = vErrors.length;}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data3 = data.Type;const _errs5 = errors;if(typeof data3 !== "string"){validate37.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema16.properties.Type.type,parentSchema:schema16.properties.Type,data:data3}];return false;}if(!(data3 === "normal")){validate37.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema16.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema16.properties.Type.enum,parentSchema:schema16.properties.Type,data:data3}];return false;}var valid0 = _errs5 === errors;}else {var valid0 = true;}}}}}else {validate37.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema16.type,parentSchema:schema16,data}];return false;}}validate37.errors = vErrors;return errors === 0;}exports.validateNewBookingResponse200 = validate40;const schema17 = {"type":"object","required":["BookingID"],"properties":{"BookingID":{"type":"string","format":"uri","description":"ID at which the booking can be managed."}},"x-standalone":false,"x-name":"newBookingResponse200","x-location":"#/paths//booking/post/responses/200/content/application/json/schema","x-schema-type":"all"};function validate40(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.BookingID === undefined) && (missing0 = "BookingID")){validate40.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema17.required,parentSchema:schema17,data}];return false;}else {if(data.BookingID !== undefined){let data0 = data.BookingID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate40.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema17.properties.BookingID,data:data0}];return false;}}else {validate40.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema17.properties.BookingID.type,parentSchema:schema17.properties.BookingID,data:data0}];return false;}}}}}}else {validate40.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema17.type,parentSchema:schema17,data}];return false;}}validate40.errors = vErrors;return errors === 0;}exports.validateNewBookingResponse500 = validate41;const schema18 = {"description":"Error description","type":"string","x-standalone":false,"x-name":"newBookingResponse500","x-location":"#/paths//booking/post/responses/500/content/application/json/schema","x-schema-type":"all"};function validate41(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate41.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema18.type,parentSchema:schema18,data}];return false;}validate41.errors = vErrors;return errors === 0;}exports.validateUpdateBookingBody = validate42;const schema19 = {"anyOf":[{"type":"object","description":"Use this request for adding devices.","properties":{"Locked":{"type":"boolean","description":"Expresses whether the devices should be locked. Must match current status of booking."},"Devices":{"type":"array","description":"List of devices which should be added.","items":{"$ref":"#/components/schemas/Device"}}}},{"type":"object","description":"Use this request for adding callbacks.","properties":{"Callback":{"type":"string","format":"uri","description":"Callback which should be called at changes."}}}],"x-standalone":false,"x-name":"updateBookingBody","x-location":"#/paths//booking/{ID}/patch/requestBody/content/application/json/schema","x-schema-type":"all"};function validate42(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;const _errs0 = errors;let valid0 = false;const _errs1 = errors;if(errors === _errs1){if(data && typeof data == "object" && !Array.isArray(data)){if(data.Locked !== undefined){let data0 = data.Locked;const _errs3 = errors;if(typeof data0 !== "boolean"){const err0 = {instancePath:instancePath+"/Locked",schemaPath:"#/anyOf/0/properties/Locked/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema19.anyOf[0].properties.Locked.type,parentSchema:schema19.anyOf[0].properties.Locked,data:data0};if(vErrors === null){vErrors = [err0];}else {vErrors.push(err0);}errors++;}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data.Devices !== undefined){let data1 = data.Devices;const _errs5 = errors;if(errors === _errs5){if(Array.isArray(data1)){var valid2 = true;const len0 = data1.length;for(let i0=0; i0<len0; i0++){const _errs7 = errors;if(!(validate24(data1[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data1,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate24.errors : vErrors.concat(validate24.errors);errors = vErrors.length;}var valid2 = _errs7 === errors;if(!valid2){break;}}}else {const err1 = {instancePath:instancePath+"/Devices",schemaPath:"#/anyOf/0/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema19.anyOf[0].properties.Devices.type,parentSchema:schema19.anyOf[0].properties.Devices,data:data1};if(vErrors === null){vErrors = [err1];}else {vErrors.push(err1);}errors++;}}var valid1 = _errs5 === errors;}else {var valid1 = true;}}}else {const err2 = {instancePath,schemaPath:"#/anyOf/0/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema19.anyOf[0].type,parentSchema:schema19.anyOf[0],data};if(vErrors === null){vErrors = [err2];}else {vErrors.push(err2);}errors++;}}var _valid0 = _errs1 === errors;valid0 = valid0 || _valid0;if(!valid0){const _errs8 = errors;if(errors === _errs8){if(data && typeof data == "object" && !Array.isArray(data)){if(data.Callback !== undefined){let data3 = data.Callback;const _errs10 = errors;if(errors === _errs10){if(errors === _errs10){if(typeof data3 === "string"){if(!(formats0(data3))){const err3 = {instancePath:instancePath+"/Callback",schemaPath:"#/anyOf/1/properties/Callback/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema19.anyOf[1].properties.Callback,data:data3};if(vErrors === null){vErrors = [err3];}else {vErrors.push(err3);}errors++;}}else {const err4 = {instancePath:instancePath+"/Callback",schemaPath:"#/anyOf/1/properties/Callback/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema19.anyOf[1].properties.Callback.type,parentSchema:schema19.anyOf[1].properties.Callback,data:data3};if(vErrors === null){vErrors = [err4];}else {vErrors.push(err4);}errors++;}}}}}else {const err5 = {instancePath,schemaPath:"#/anyOf/1/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema19.anyOf[1].type,parentSchema:schema19.anyOf[1],data};if(vErrors === null){vErrors = [err5];}else {vErrors.push(err5);}errors++;}}var _valid0 = _errs8 === errors;valid0 = valid0 || _valid0;}if(!valid0){const err6 = {instancePath,schemaPath:"#/anyOf",keyword:"anyOf",params:{},message:"must match a schema in anyOf",schema:schema19.anyOf,parentSchema:schema19,data};if(vErrors === null){vErrors = [err6];}else {vErrors.push(err6);}errors++;validate42.errors = vErrors;return false;}else {errors = _errs0;if(vErrors !== null){if(_errs0){vErrors.length = _errs0;}else {vErrors = null;}}}validate42.errors = vErrors;return errors === 0;}exports.validateUpdateBookingResponse200 = validate44;const schema20 = {"type":"object","required":["BookingID"],"properties":{"BookingID":{"type":"string","format":"uri"}},"x-standalone":false,"x-name":"updateBookingResponse200","x-location":"#/paths//booking/{ID}/patch/responses/200/content/application/json/schema","x-schema-type":"all"};function validate44(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.BookingID === undefined) && (missing0 = "BookingID")){validate44.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema20.required,parentSchema:schema20,data}];return false;}else {if(data.BookingID !== undefined){let data0 = data.BookingID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate44.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema20.properties.BookingID,data:data0}];return false;}}else {validate44.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema20.properties.BookingID.type,parentSchema:schema20.properties.BookingID,data:data0}];return false;}}}}}}else {validate44.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema20.type,parentSchema:schema20,data}];return false;}}validate44.errors = vErrors;return errors === 0;}exports.validateUpdateBookingResponse500 = validate45;const schema21 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"updateBookingResponse500","x-location":"#/paths//booking/{ID}/patch/responses/500/content/application/json/schema","x-schema-type":"all"};function validate45(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate45.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema21.type,parentSchema:schema21,data}];return false;}validate45.errors = vErrors;return errors === 0;}exports.validateDeleteBookingResponse500 = validate46;const schema22 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"deleteBookingResponse500","x-location":"#/paths//booking/{ID}/delete/responses/500/content/application/json/schema","x-schema-type":"all"};function validate46(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate46.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema22.type,parentSchema:schema22,data}];return false;}validate46.errors = vErrors;return errors === 0;}exports.validateGetBookingResponse200 = validate47;const schema23 = {"type":"object","required":["Booking","Locked"],"properties":{"Booking":{"$ref":"#/components/schemas/Booking"},"Locked":{"type":"boolean","description":"Shows if the booking is in a locked status."}},"x-standalone":false,"x-name":"getBookingResponse200","x-location":"#/paths//booking/{ID}/get/responses/200/content/application/json/schema","x-schema-type":"all"};function validate47(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Booking === undefined) && (missing0 = "Booking")) || ((data.Locked === undefined) && (missing0 = "Locked"))){validate47.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema23.required,parentSchema:schema23,data}];return false;}else {if(data.Booking !== undefined){const _errs1 = errors;if(!(validate21(data.Booking, {instancePath:instancePath+"/Booking",parentData:data,parentDataProperty:"Booking",rootData}))){vErrors = vErrors === null ? validate21.errors : vErrors.concat(validate21.errors);errors = vErrors.length;}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Locked !== undefined){let data1 = data.Locked;const _errs2 = errors;if(typeof data1 !== "boolean"){validate47.errors = [{instancePath:instancePath+"/Locked",schemaPath:"#/properties/Locked/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema23.properties.Locked.type,parentSchema:schema23.properties.Locked,data:data1}];return false;}var valid0 = _errs2 === errors;}else {var valid0 = true;}}}}else {validate47.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema23.type,parentSchema:schema23,data}];return false;}}validate47.errors = vErrors;return errors === 0;}exports.validateGetBookingResponse500 = validate49;const schema24 = {"type":"string","description":"Error code","x-standalone":false,"x-name":"getBookingResponse500","x-location":"#/paths//booking/{ID}/get/responses/500/content/application/json/schema","x-schema-type":"all"};function validate49(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate49.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema24.type,parentSchema:schema24,data}];return false;}validate49.errors = vErrors;return errors === 0;}exports.validateDestroyBookingResponse500 = validate50;const schema25 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"destroyBookingResponse500","x-location":"#/paths//booking/{ID}/destroy/delete/responses/500/content/application/json/schema","x-schema-type":"all"};function validate50(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate50.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema25.type,parentSchema:schema25,data}];return false;}validate50.errors = vErrors;return errors === 0;}exports.validateLockBookingResponse200 = validate51;const schema26 = {"type":"array","description":"The list of booked devices and selected real devices. Order is guaranteed to be the same as in the booking.","items":{"type":"object","required":["Requested","Selected"],"properties":{"Requested":{"type":"string","format":"uri"},"Selected":{"type":"string","format":"uri"}}},"x-standalone":false,"x-name":"lockBookingResponse200","x-location":"#/paths//booking/{ID}/lock/put/responses/200/content/application/json/schema","x-schema-type":"all"};function validate51(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(Array.isArray(data)){var valid0 = true;const len0 = data.length;for(let i0=0; i0<len0; i0++){let data0 = data[i0];const _errs1 = errors;if(errors === _errs1){if(data0 && typeof data0 == "object" && !Array.isArray(data0)){let missing0;if(((data0.Requested === undefined) && (missing0 = "Requested")) || ((data0.Selected === undefined) && (missing0 = "Selected"))){validate51.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema26.items.required,parentSchema:schema26.items,data:data0}];return false;}else {if(data0.Requested !== undefined){let data1 = data0.Requested;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats0(data1))){validate51.errors = [{instancePath:instancePath+"/" + i0+"/Requested",schemaPath:"#/items/properties/Requested/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema26.items.properties.Requested,data:data1}];return false;}}else {validate51.errors = [{instancePath:instancePath+"/" + i0+"/Requested",schemaPath:"#/items/properties/Requested/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema26.items.properties.Requested.type,parentSchema:schema26.items.properties.Requested,data:data1}];return false;}}}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data0.Selected !== undefined){let data2 = data0.Selected;const _errs5 = errors;if(errors === _errs5){if(errors === _errs5){if(typeof data2 === "string"){if(!(formats0(data2))){validate51.errors = [{instancePath:instancePath+"/" + i0+"/Selected",schemaPath:"#/items/properties/Selected/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema26.items.properties.Selected,data:data2}];return false;}}else {validate51.errors = [{instancePath:instancePath+"/" + i0+"/Selected",schemaPath:"#/items/properties/Selected/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema26.items.properties.Selected.type,parentSchema:schema26.items.properties.Selected,data:data2}];return false;}}}var valid1 = _errs5 === errors;}else {var valid1 = true;}}}}else {validate51.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema26.items.type,parentSchema:schema26.items,data:data0}];return false;}}var valid0 = _errs1 === errors;if(!valid0){break;}}}else {validate51.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema26.type,parentSchema:schema26,data}];return false;}}validate51.errors = vErrors;return errors === 0;}exports.validateLockBookingResponse500 = validate52;const schema27 = {"type":"string","description":"Error string","x-standalone":false,"x-name":"lockBookingResponse500","x-location":"#/paths//booking/{ID}/lock/put/responses/500/content/application/json/schema","x-schema-type":"all"};function validate52(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate52.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema27.type,parentSchema:schema27,data}];return false;}validate52.errors = vErrors;return errors === 0;}exports.validateUnlockBookingResponse500 = validate53;const schema28 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"unlockBookingResponse500","x-location":"#/paths//booking/{ID}/lock/delete/responses/500/content/application/json/schema","x-schema-type":"all"};function validate53(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate53.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema28.type,parentSchema:schema28,data}];return false;}validate53.errors = vErrors;return errors === 0;}exports.validateBookingCallbackResponse500 = validate54;const schema29 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"bookingCallbackResponse500","x-location":"#/paths//booking_callback/{ID}/post/responses/500/content/application/json/schema","x-schema-type":"all"};function validate54(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate54.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema29.type,parentSchema:schema29,data}];return false;}validate54.errors = vErrors;return errors === 0;}exports.validateBookingRequest = validate55;const schema30 = {"title":"Booking","description":"A booking in the booking system.","type":"object","required":["ID","Time","Devices","Status","You","External"],"properties":{"ID":{"type":"string","format":"uri","description":"Unique ID of the booking."},"Time":{"$ref":"#/components/schemas/Timeslot_request"},"Devices":{"type":"array","items":{"type":"string","format":"uri"}},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]},"Status":{"description":"Current status of the booking. While the booking is pending, it can not be used. Will change automatically and can not be set by user. 'rejected' is set when the initial booking failed, 'cancelled' when the booking was deleted / cancelled after it was once active. The 'active-*' will be used when a device was added after the booking was locked.","type":"string","enum":["pending","booked","rejected","cancelled","active","active-pending","active-rejected"]},"You":{"type":"boolean","description":"If true, this booking was done by you."},"External":{"type":"boolean","description":"Shows whether the booking was done by an external institution."},"Message":{"type":"string","description":"User readable notes about the status of the booking (e.g. if devices are unknown)."}},"x-standalone":true,"x-name":"BookingRequest","x-location":"#/components/schemas/Booking_request","x-schema-type":"request"};const schema31 = {"title":"Timeslot","description":"A time slot represents a slice of time used for bookings.","type":"object","required":["Start","End"],"properties":{"Start":{"type":"string","description":"Start time of the booking.","format":"date-time"},"End":{"type":"string","description":"End time of the booking.","format":"date-time"}},"x-standalone":true,"x-name":"TimeslotRequest","x-location":"#/components/schemas/Timeslot_request","x-schema-type":"request"};function validate56(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Start === undefined) && (missing0 = "Start")) || ((data.End === undefined) && (missing0 = "End"))){validate56.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema31.required,parentSchema:schema31,data}];return false;}else {if(data.Start !== undefined){let data0 = data.Start;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats2.validate(data0))){validate56.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema31.properties.Start,data:data0}];return false;}}else {validate56.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema31.properties.Start.type,parentSchema:schema31.properties.Start,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.End !== undefined){let data1 = data.End;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats2.validate(data1))){validate56.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema31.properties.End,data:data1}];return false;}}else {validate56.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema31.properties.End.type,parentSchema:schema31.properties.End,data:data1}];return false;}}}var valid0 = _errs3 === errors;}else {var valid0 = true;}}}}else {validate56.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema31.type,parentSchema:schema31,data}];return false;}}validate56.errors = vErrors;return errors === 0;}function validate55(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((((((data.ID === undefined) && (missing0 = "ID")) || ((data.Time === undefined) && (missing0 = "Time"))) || ((data.Devices === undefined) && (missing0 = "Devices"))) || ((data.Status === undefined) && (missing0 = "Status"))) || ((data.You === undefined) && (missing0 = "You"))) || ((data.External === undefined) && (missing0 = "External"))){validate55.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema30.required,parentSchema:schema30,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate55.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema30.properties.ID,data:data0}];return false;}}else {validate55.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema30.properties.ID.type,parentSchema:schema30.properties.ID,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs3 = errors;if(!(validate56(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate56.errors : vErrors.concat(validate56.errors);errors = vErrors.length;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.Devices !== undefined){let data2 = data.Devices;const _errs4 = errors;if(errors === _errs4){if(Array.isArray(data2)){var valid1 = true;const len0 = data2.length;for(let i0=0; i0<len0; i0++){let data3 = data2[i0];const _errs6 = errors;if(errors === _errs6){if(errors === _errs6){if(typeof data3 === "string"){if(!(formats0(data3))){validate55.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema30.properties.Devices.items,data:data3}];return false;}}else {validate55.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema30.properties.Devices.items.type,parentSchema:schema30.properties.Devices.items,data:data3}];return false;}}}var valid1 = _errs6 === errors;if(!valid1){break;}}}else {validate55.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema30.properties.Devices.type,parentSchema:schema30.properties.Devices,data:data2}];return false;}}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data4 = data.Type;const _errs8 = errors;if(typeof data4 !== "string"){validate55.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema30.properties.Type.type,parentSchema:schema30.properties.Type,data:data4}];return false;}if(!(data4 === "normal")){validate55.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema30.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema30.properties.Type.enum,parentSchema:schema30.properties.Type,data:data4}];return false;}var valid0 = _errs8 === errors;}else {var valid0 = true;}if(valid0){if(data.Status !== undefined){let data5 = data.Status;const _errs10 = errors;if(typeof data5 !== "string"){validate55.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema30.properties.Status.type,parentSchema:schema30.properties.Status,data:data5}];return false;}if(!(((((((data5 === "pending") || (data5 === "booked")) || (data5 === "rejected")) || (data5 === "cancelled")) || (data5 === "active")) || (data5 === "active-pending")) || (data5 === "active-rejected"))){validate55.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/enum",keyword:"enum",params:{allowedValues: schema30.properties.Status.enum},message:"must be equal to one of the allowed values",schema:schema30.properties.Status.enum,parentSchema:schema30.properties.Status,data:data5}];return false;}var valid0 = _errs10 === errors;}else {var valid0 = true;}if(valid0){if(data.You !== undefined){let data6 = data.You;const _errs12 = errors;if(typeof data6 !== "boolean"){validate55.errors = [{instancePath:instancePath+"/You",schemaPath:"#/properties/You/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema30.properties.You.type,parentSchema:schema30.properties.You,data:data6}];return false;}var valid0 = _errs12 === errors;}else {var valid0 = true;}if(valid0){if(data.External !== undefined){let data7 = data.External;const _errs14 = errors;if(typeof data7 !== "boolean"){validate55.errors = [{instancePath:instancePath+"/External",schemaPath:"#/properties/External/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema30.properties.External.type,parentSchema:schema30.properties.External,data:data7}];return false;}var valid0 = _errs14 === errors;}else {var valid0 = true;}if(valid0){if(data.Message !== undefined){let data8 = data.Message;const _errs16 = errors;if(typeof data8 !== "string"){validate55.errors = [{instancePath:instancePath+"/Message",schemaPath:"#/properties/Message/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema30.properties.Message.type,parentSchema:schema30.properties.Message,data:data8}];return false;}var valid0 = _errs16 === errors;}else {var valid0 = true;}}}}}}}}}}else {validate55.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema30.type,parentSchema:schema30,data}];return false;}}validate55.errors = vErrors;return errors === 0;}exports.validateBookingResponse = validate58;const schema32 = {"title":"Booking","description":"A booking in the booking system.","type":"object","required":["ID","Time","Devices","Status","You","External"],"properties":{"ID":{"type":"string","format":"uri","description":"Unique ID of the booking."},"Time":{"$ref":"#/components/schemas/Timeslot_response"},"Devices":{"type":"array","items":{"type":"string","format":"uri"}},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]},"Status":{"description":"Current status of the booking. While the booking is pending, it can not be used. Will change automatically and can not be set by user. 'rejected' is set when the initial booking failed, 'cancelled' when the booking was deleted / cancelled after it was once active. The 'active-*' will be used when a device was added after the booking was locked.","type":"string","enum":["pending","booked","rejected","cancelled","active","active-pending","active-rejected"]},"You":{"type":"boolean","description":"If true, this booking was done by you."},"External":{"type":"boolean","description":"Shows whether the booking was done by an external institution."},"Message":{"type":"string","description":"User readable notes about the status of the booking (e.g. if devices are unknown)."}},"x-standalone":true,"x-name":"BookingResponse","x-location":"#/components/schemas/Booking_response","x-schema-type":"response"};const schema33 = {"title":"Timeslot","description":"A time slot represents a slice of time used for bookings.","type":"object","required":["Start","End"],"properties":{"Start":{"type":"string","description":"Start time of the booking.","format":"date-time"},"End":{"type":"string","description":"End time of the booking.","format":"date-time"}},"x-standalone":true,"x-name":"TimeslotResponse","x-location":"#/components/schemas/Timeslot_response","x-schema-type":"response"};function validate59(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Start === undefined) && (missing0 = "Start")) || ((data.End === undefined) && (missing0 = "End"))){validate59.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema33.required,parentSchema:schema33,data}];return false;}else {if(data.Start !== undefined){let data0 = data.Start;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats2.validate(data0))){validate59.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema33.properties.Start,data:data0}];return false;}}else {validate59.errors = [{instancePath:instancePath+"/Start",schemaPath:"#/properties/Start/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema33.properties.Start.type,parentSchema:schema33.properties.Start,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.End !== undefined){let data1 = data.End;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats2.validate(data1))){validate59.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/format",keyword:"format",params:{format: "date-time"},message:"must match format \""+"date-time"+"\"",schema:"date-time",parentSchema:schema33.properties.End,data:data1}];return false;}}else {validate59.errors = [{instancePath:instancePath+"/End",schemaPath:"#/properties/End/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema33.properties.End.type,parentSchema:schema33.properties.End,data:data1}];return false;}}}var valid0 = _errs3 === errors;}else {var valid0 = true;}}}}else {validate59.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema33.type,parentSchema:schema33,data}];return false;}}validate59.errors = vErrors;return errors === 0;}function validate58(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((((((data.ID === undefined) && (missing0 = "ID")) || ((data.Time === undefined) && (missing0 = "Time"))) || ((data.Devices === undefined) && (missing0 = "Devices"))) || ((data.Status === undefined) && (missing0 = "Status"))) || ((data.You === undefined) && (missing0 = "You"))) || ((data.External === undefined) && (missing0 = "External"))){validate58.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema32.required,parentSchema:schema32,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate58.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema32.properties.ID,data:data0}];return false;}}else {validate58.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema32.properties.ID.type,parentSchema:schema32.properties.ID,data:data0}];return false;}}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs3 = errors;if(!(validate59(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate59.errors : vErrors.concat(validate59.errors);errors = vErrors.length;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.Devices !== undefined){let data2 = data.Devices;const _errs4 = errors;if(errors === _errs4){if(Array.isArray(data2)){var valid1 = true;const len0 = data2.length;for(let i0=0; i0<len0; i0++){let data3 = data2[i0];const _errs6 = errors;if(errors === _errs6){if(errors === _errs6){if(typeof data3 === "string"){if(!(formats0(data3))){validate58.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema32.properties.Devices.items,data:data3}];return false;}}else {validate58.errors = [{instancePath:instancePath+"/Devices/" + i0,schemaPath:"#/properties/Devices/items/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema32.properties.Devices.items.type,parentSchema:schema32.properties.Devices.items,data:data3}];return false;}}}var valid1 = _errs6 === errors;if(!valid1){break;}}}else {validate58.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema32.properties.Devices.type,parentSchema:schema32.properties.Devices,data:data2}];return false;}}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data4 = data.Type;const _errs8 = errors;if(typeof data4 !== "string"){validate58.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema32.properties.Type.type,parentSchema:schema32.properties.Type,data:data4}];return false;}if(!(data4 === "normal")){validate58.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema32.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema32.properties.Type.enum,parentSchema:schema32.properties.Type,data:data4}];return false;}var valid0 = _errs8 === errors;}else {var valid0 = true;}if(valid0){if(data.Status !== undefined){let data5 = data.Status;const _errs10 = errors;if(typeof data5 !== "string"){validate58.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema32.properties.Status.type,parentSchema:schema32.properties.Status,data:data5}];return false;}if(!(((((((data5 === "pending") || (data5 === "booked")) || (data5 === "rejected")) || (data5 === "cancelled")) || (data5 === "active")) || (data5 === "active-pending")) || (data5 === "active-rejected"))){validate58.errors = [{instancePath:instancePath+"/Status",schemaPath:"#/properties/Status/enum",keyword:"enum",params:{allowedValues: schema32.properties.Status.enum},message:"must be equal to one of the allowed values",schema:schema32.properties.Status.enum,parentSchema:schema32.properties.Status,data:data5}];return false;}var valid0 = _errs10 === errors;}else {var valid0 = true;}if(valid0){if(data.You !== undefined){let data6 = data.You;const _errs12 = errors;if(typeof data6 !== "boolean"){validate58.errors = [{instancePath:instancePath+"/You",schemaPath:"#/properties/You/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema32.properties.You.type,parentSchema:schema32.properties.You,data:data6}];return false;}var valid0 = _errs12 === errors;}else {var valid0 = true;}if(valid0){if(data.External !== undefined){let data7 = data.External;const _errs14 = errors;if(typeof data7 !== "boolean"){validate58.errors = [{instancePath:instancePath+"/External",schemaPath:"#/properties/External/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema32.properties.External.type,parentSchema:schema32.properties.External,data:data7}];return false;}var valid0 = _errs14 === errors;}else {var valid0 = true;}if(valid0){if(data.Message !== undefined){let data8 = data.Message;const _errs16 = errors;if(typeof data8 !== "string"){validate58.errors = [{instancePath:instancePath+"/Message",schemaPath:"#/properties/Message/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema32.properties.Message.type,parentSchema:schema32.properties.Message,data:data8}];return false;}var valid0 = _errs16 === errors;}else {var valid0 = true;}}}}}}}}}}else {validate58.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema32.type,parentSchema:schema32,data}];return false;}}validate58.errors = vErrors;return errors === 0;}exports.validateDeviceRequest = validate61;const schema34 = {"title":"Device","description":"A device might either be a physical/virtual device or a group of device.","type":"object","required":["ID"],"properties":{"ID":{"type":"string","description":"Unique ID of the device. Contains the institution (by having an end point at that institution)","format":"uri"}},"x-standalone":true,"x-name":"DeviceRequest","x-location":"#/components/schemas/Device_request","x-schema-type":"request"};function validate61(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.ID === undefined) && (missing0 = "ID")){validate61.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema34.required,parentSchema:schema34,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate61.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema34.properties.ID,data:data0}];return false;}}else {validate61.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema34.properties.ID.type,parentSchema:schema34.properties.ID,data:data0}];return false;}}}}}}else {validate61.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema34.type,parentSchema:schema34,data}];return false;}}validate61.errors = vErrors;return errors === 0;}exports.validateDeviceResponse = validate62;const schema35 = {"title":"Device","description":"A device might either be a physical/virtual device or a group of device.","type":"object","required":["ID"],"properties":{"ID":{"type":"string","description":"Unique ID of the device. Contains the institution (by having an end point at that institution)","format":"uri"}},"x-standalone":true,"x-name":"DeviceResponse","x-location":"#/components/schemas/Device_response","x-schema-type":"response"};function validate62(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.ID === undefined) && (missing0 = "ID")){validate62.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema35.required,parentSchema:schema35,data}];return false;}else {if(data.ID !== undefined){let data0 = data.ID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate62.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema35.properties.ID,data:data0}];return false;}}else {validate62.errors = [{instancePath:instancePath+"/ID",schemaPath:"#/properties/ID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema35.properties.ID.type,parentSchema:schema35.properties.ID,data:data0}];return false;}}}}}}else {validate62.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema35.type,parentSchema:schema35,data}];return false;}}validate62.errors = vErrors;return errors === 0;}exports.validateExperimentRequest = validate63;const schema36 = {"title":"Experiment","description":"An experiment describes a set of devices and how they should be connected (potentially among other metadata).","type":"object","required":["Devices"],"properties":{"Devices":{"type":"array","description":"List of devices used in experiment.","items":{"$ref":"#/components/schemas/Device_request"}},"Description":{"type":"string","description":"User provided description, for example might be a reason for the booking (e.g. maintenance) or a link to the experiment. Might be empty or missing."}},"x-standalone":true,"x-name":"ExperimentRequest","x-location":"#/components/schemas/Experiment_request","x-schema-type":"request"};function validate63(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.Devices === undefined) && (missing0 = "Devices")){validate63.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema36.required,parentSchema:schema36,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate61(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate61.errors : vErrors.concat(validate61.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate63.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema36.properties.Devices.type,parentSchema:schema36.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Description !== undefined){let data2 = data.Description;const _errs4 = errors;if(typeof data2 !== "string"){validate63.errors = [{instancePath:instancePath+"/Description",schemaPath:"#/properties/Description/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema36.properties.Description.type,parentSchema:schema36.properties.Description,data:data2}];return false;}var valid0 = _errs4 === errors;}else {var valid0 = true;}}}}else {validate63.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema36.type,parentSchema:schema36,data}];return false;}}validate63.errors = vErrors;return errors === 0;}exports.validateExperimentResponse = validate65;const schema37 = {"title":"Experiment","description":"An experiment describes a set of devices and how they should be connected (potentially among other metadata).","type":"object","required":["Devices"],"properties":{"Devices":{"type":"array","description":"List of devices used in experiment.","items":{"$ref":"#/components/schemas/Device_response"}},"Description":{"type":"string","description":"User provided description, for example might be a reason for the booking (e.g. maintenance) or a link to the experiment. Might be empty or missing."}},"x-standalone":true,"x-name":"ExperimentResponse","x-location":"#/components/schemas/Experiment_response","x-schema-type":"response"};function validate65(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.Devices === undefined) && (missing0 = "Devices")){validate65.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema37.required,parentSchema:schema37,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate62(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate62.errors : vErrors.concat(validate62.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate65.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema37.properties.Devices.type,parentSchema:schema37.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Description !== undefined){let data2 = data.Description;const _errs4 = errors;if(typeof data2 !== "string"){validate65.errors = [{instancePath:instancePath+"/Description",schemaPath:"#/properties/Description/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema37.properties.Description.type,parentSchema:schema37.properties.Description,data:data2}];return false;}var valid0 = _errs4 === errors;}else {var valid0 = true;}}}}else {validate65.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema37.type,parentSchema:schema37,data}];return false;}}validate65.errors = vErrors;return errors === 0;}exports.validateTimeslotRequest = validate56;exports.validateTimeslotResponse = validate59;exports.validateIDRequest = validate67;const schema38 = {"type":"string","x-standalone":false,"x-name":"IDRequest","x-location":"#/components/parameters/ID/schema_request","x-schema-type":"request"};function validate67(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate67.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema38.type,parentSchema:schema38,data}];return false;}validate67.errors = vErrors;return errors === 0;}exports.validateIDResponse = validate68;const schema39 = {"type":"string","x-standalone":false,"x-name":"IDResponse","x-location":"#/components/parameters/ID/schema_response","x-schema-type":"response"};function validate68(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate68.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema39.type,parentSchema:schema39,data}];return false;}validate68.errors = vErrors;return errors === 0;}exports.validateScheduleBodyRequest = validate69;const schema40 = {"type":"object","required":["Experiment","Time"],"properties":{"Experiment":{"$ref":"#/components/schemas/Experiment_request"},"Time":{"$ref":"#/components/schemas/Timeslot_request"},"Combined":{"type":"boolean","description":"If true, show only one timetable per device instead of one for all available physical devices."},"onlyOwn":{"type":"boolean","description":"(private) Show only devices of this institution. Give an error if a device of an other institution is requested."}},"x-standalone":false,"x-name":"scheduleBodyRequest","x-location":"#/paths//schedule/post/requestBody/content/application/json/schema_request","x-schema-type":"request"};function validate69(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Experiment === undefined) && (missing0 = "Experiment")) || ((data.Time === undefined) && (missing0 = "Time"))){validate69.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema40.required,parentSchema:schema40,data}];return false;}else {if(data.Experiment !== undefined){const _errs1 = errors;if(!(validate63(data.Experiment, {instancePath:instancePath+"/Experiment",parentData:data,parentDataProperty:"Experiment",rootData}))){vErrors = vErrors === null ? validate63.errors : vErrors.concat(validate63.errors);errors = vErrors.length;}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs2 = errors;if(!(validate56(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate56.errors : vErrors.concat(validate56.errors);errors = vErrors.length;}var valid0 = _errs2 === errors;}else {var valid0 = true;}if(valid0){if(data.Combined !== undefined){let data2 = data.Combined;const _errs3 = errors;if(typeof data2 !== "boolean"){validate69.errors = [{instancePath:instancePath+"/Combined",schemaPath:"#/properties/Combined/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema40.properties.Combined.type,parentSchema:schema40.properties.Combined,data:data2}];return false;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.onlyOwn !== undefined){let data3 = data.onlyOwn;const _errs5 = errors;if(typeof data3 !== "boolean"){validate69.errors = [{instancePath:instancePath+"/onlyOwn",schemaPath:"#/properties/onlyOwn/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema40.properties.onlyOwn.type,parentSchema:schema40.properties.onlyOwn,data:data3}];return false;}var valid0 = _errs5 === errors;}else {var valid0 = true;}}}}}}else {validate69.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema40.type,parentSchema:schema40,data}];return false;}}validate69.errors = vErrors;return errors === 0;}exports.validateScheduleBodyResponse = validate72;const schema41 = {"type":"object","required":["Experiment","Time"],"properties":{"Experiment":{"$ref":"#/components/schemas/Experiment_response"},"Time":{"$ref":"#/components/schemas/Timeslot_response"},"Combined":{"type":"boolean","description":"If true, show only one timetable per device instead of one for all available physical devices."},"onlyOwn":{"type":"boolean","description":"(private) Show only devices of this institution. Give an error if a device of an other institution is requested."}},"x-standalone":false,"x-name":"scheduleBodyResponse","x-location":"#/paths//schedule/post/requestBody/content/application/json/schema_response","x-schema-type":"response"};function validate72(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Experiment === undefined) && (missing0 = "Experiment")) || ((data.Time === undefined) && (missing0 = "Time"))){validate72.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema41.required,parentSchema:schema41,data}];return false;}else {if(data.Experiment !== undefined){const _errs1 = errors;if(!(validate65(data.Experiment, {instancePath:instancePath+"/Experiment",parentData:data,parentDataProperty:"Experiment",rootData}))){vErrors = vErrors === null ? validate65.errors : vErrors.concat(validate65.errors);errors = vErrors.length;}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs2 = errors;if(!(validate59(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate59.errors : vErrors.concat(validate59.errors);errors = vErrors.length;}var valid0 = _errs2 === errors;}else {var valid0 = true;}if(valid0){if(data.Combined !== undefined){let data2 = data.Combined;const _errs3 = errors;if(typeof data2 !== "boolean"){validate72.errors = [{instancePath:instancePath+"/Combined",schemaPath:"#/properties/Combined/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema41.properties.Combined.type,parentSchema:schema41.properties.Combined,data:data2}];return false;}var valid0 = _errs3 === errors;}else {var valid0 = true;}if(valid0){if(data.onlyOwn !== undefined){let data3 = data.onlyOwn;const _errs5 = errors;if(typeof data3 !== "boolean"){validate72.errors = [{instancePath:instancePath+"/onlyOwn",schemaPath:"#/properties/onlyOwn/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema41.properties.onlyOwn.type,parentSchema:schema41.properties.onlyOwn,data:data3}];return false;}var valid0 = _errs5 === errors;}else {var valid0 = true;}}}}}}else {validate72.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema41.type,parentSchema:schema41,data}];return false;}}validate72.errors = vErrors;return errors === 0;}exports.validateScheduleResponse200Request = validate75;const schema42 = {"type":"array","items":{"type":"object","required":["Device","Booked","Free"],"properties":{"Device":{"type":"string","description":"ID of the device (or * if combined)."},"Booked":{"type":"array","description":"Array of booked times.","items":{"$ref":"#/components/schemas/Timeslot_request"}},"Free":{"type":"array","description":"Array of free times.","items":{"$ref":"#/components/schemas/Timeslot_request"}}}},"x-standalone":false,"x-name":"scheduleResponse200Request","x-location":"#/paths//schedule/post/responses/200/content/application/json/schema_request","x-schema-type":"request"};function validate75(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(Array.isArray(data)){var valid0 = true;const len0 = data.length;for(let i0=0; i0<len0; i0++){let data0 = data[i0];const _errs1 = errors;if(errors === _errs1){if(data0 && typeof data0 == "object" && !Array.isArray(data0)){let missing0;if((((data0.Device === undefined) && (missing0 = "Device")) || ((data0.Booked === undefined) && (missing0 = "Booked"))) || ((data0.Free === undefined) && (missing0 = "Free"))){validate75.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema42.items.required,parentSchema:schema42.items,data:data0}];return false;}else {if(data0.Device !== undefined){let data1 = data0.Device;const _errs3 = errors;if(typeof data1 !== "string"){validate75.errors = [{instancePath:instancePath+"/" + i0+"/Device",schemaPath:"#/items/properties/Device/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema42.items.properties.Device.type,parentSchema:schema42.items.properties.Device,data:data1}];return false;}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data0.Booked !== undefined){let data2 = data0.Booked;const _errs5 = errors;if(errors === _errs5){if(Array.isArray(data2)){var valid2 = true;const len1 = data2.length;for(let i1=0; i1<len1; i1++){const _errs7 = errors;if(!(validate56(data2[i1], {instancePath:instancePath+"/" + i0+"/Booked/" + i1,parentData:data2,parentDataProperty:i1,rootData}))){vErrors = vErrors === null ? validate56.errors : vErrors.concat(validate56.errors);errors = vErrors.length;}var valid2 = _errs7 === errors;if(!valid2){break;}}}else {validate75.errors = [{instancePath:instancePath+"/" + i0+"/Booked",schemaPath:"#/items/properties/Booked/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema42.items.properties.Booked.type,parentSchema:schema42.items.properties.Booked,data:data2}];return false;}}var valid1 = _errs5 === errors;}else {var valid1 = true;}if(valid1){if(data0.Free !== undefined){let data4 = data0.Free;const _errs8 = errors;if(errors === _errs8){if(Array.isArray(data4)){var valid3 = true;const len2 = data4.length;for(let i2=0; i2<len2; i2++){const _errs10 = errors;if(!(validate56(data4[i2], {instancePath:instancePath+"/" + i0+"/Free/" + i2,parentData:data4,parentDataProperty:i2,rootData}))){vErrors = vErrors === null ? validate56.errors : vErrors.concat(validate56.errors);errors = vErrors.length;}var valid3 = _errs10 === errors;if(!valid3){break;}}}else {validate75.errors = [{instancePath:instancePath+"/" + i0+"/Free",schemaPath:"#/items/properties/Free/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema42.items.properties.Free.type,parentSchema:schema42.items.properties.Free,data:data4}];return false;}}var valid1 = _errs8 === errors;}else {var valid1 = true;}}}}}else {validate75.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema42.items.type,parentSchema:schema42.items,data:data0}];return false;}}var valid0 = _errs1 === errors;if(!valid0){break;}}}else {validate75.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema42.type,parentSchema:schema42,data}];return false;}}validate75.errors = vErrors;return errors === 0;}exports.validateScheduleResponse200Response = validate78;const schema43 = {"type":"array","items":{"type":"object","required":["Device","Booked","Free"],"properties":{"Device":{"type":"string","description":"ID of the device (or * if combined)."},"Booked":{"type":"array","description":"Array of booked times.","items":{"$ref":"#/components/schemas/Timeslot_response"}},"Free":{"type":"array","description":"Array of free times.","items":{"$ref":"#/components/schemas/Timeslot_response"}}}},"x-standalone":false,"x-name":"scheduleResponse200Response","x-location":"#/paths//schedule/post/responses/200/content/application/json/schema_response","x-schema-type":"response"};function validate78(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(Array.isArray(data)){var valid0 = true;const len0 = data.length;for(let i0=0; i0<len0; i0++){let data0 = data[i0];const _errs1 = errors;if(errors === _errs1){if(data0 && typeof data0 == "object" && !Array.isArray(data0)){let missing0;if((((data0.Device === undefined) && (missing0 = "Device")) || ((data0.Booked === undefined) && (missing0 = "Booked"))) || ((data0.Free === undefined) && (missing0 = "Free"))){validate78.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema43.items.required,parentSchema:schema43.items,data:data0}];return false;}else {if(data0.Device !== undefined){let data1 = data0.Device;const _errs3 = errors;if(typeof data1 !== "string"){validate78.errors = [{instancePath:instancePath+"/" + i0+"/Device",schemaPath:"#/items/properties/Device/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema43.items.properties.Device.type,parentSchema:schema43.items.properties.Device,data:data1}];return false;}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data0.Booked !== undefined){let data2 = data0.Booked;const _errs5 = errors;if(errors === _errs5){if(Array.isArray(data2)){var valid2 = true;const len1 = data2.length;for(let i1=0; i1<len1; i1++){const _errs7 = errors;if(!(validate59(data2[i1], {instancePath:instancePath+"/" + i0+"/Booked/" + i1,parentData:data2,parentDataProperty:i1,rootData}))){vErrors = vErrors === null ? validate59.errors : vErrors.concat(validate59.errors);errors = vErrors.length;}var valid2 = _errs7 === errors;if(!valid2){break;}}}else {validate78.errors = [{instancePath:instancePath+"/" + i0+"/Booked",schemaPath:"#/items/properties/Booked/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema43.items.properties.Booked.type,parentSchema:schema43.items.properties.Booked,data:data2}];return false;}}var valid1 = _errs5 === errors;}else {var valid1 = true;}if(valid1){if(data0.Free !== undefined){let data4 = data0.Free;const _errs8 = errors;if(errors === _errs8){if(Array.isArray(data4)){var valid3 = true;const len2 = data4.length;for(let i2=0; i2<len2; i2++){const _errs10 = errors;if(!(validate59(data4[i2], {instancePath:instancePath+"/" + i0+"/Free/" + i2,parentData:data4,parentDataProperty:i2,rootData}))){vErrors = vErrors === null ? validate59.errors : vErrors.concat(validate59.errors);errors = vErrors.length;}var valid3 = _errs10 === errors;if(!valid3){break;}}}else {validate78.errors = [{instancePath:instancePath+"/" + i0+"/Free",schemaPath:"#/items/properties/Free/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema43.items.properties.Free.type,parentSchema:schema43.items.properties.Free,data:data4}];return false;}}var valid1 = _errs8 === errors;}else {var valid1 = true;}}}}}else {validate78.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema43.items.type,parentSchema:schema43.items,data:data0}];return false;}}var valid0 = _errs1 === errors;if(!valid0){break;}}}else {validate78.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema43.type,parentSchema:schema43,data}];return false;}}validate78.errors = vErrors;return errors === 0;}exports.validateScheduleResponse404Request = validate81;const schema44 = {"type":"string","description":"First unknown device ID.","x-standalone":false,"x-name":"scheduleResponse404Request","x-location":"#/paths//schedule/post/responses/404/content/application/json/schema_request","x-schema-type":"request"};function validate81(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate81.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema44.type,parentSchema:schema44,data}];return false;}validate81.errors = vErrors;return errors === 0;}exports.validateScheduleResponse404Response = validate82;const schema45 = {"type":"string","description":"First unknown device ID.","x-standalone":false,"x-name":"scheduleResponse404Response","x-location":"#/paths//schedule/post/responses/404/content/application/json/schema_response","x-schema-type":"response"};function validate82(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate82.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema45.type,parentSchema:schema45,data}];return false;}validate82.errors = vErrors;return errors === 0;}exports.validateScheduleResponse422Request = validate83;const schema46 = {"type":"string","description":"First virtual device ID.","x-standalone":false,"x-name":"scheduleResponse422Request","x-location":"#/paths//schedule/post/responses/422/content/application/json/schema_request","x-schema-type":"request"};function validate83(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate83.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema46.type,parentSchema:schema46,data}];return false;}validate83.errors = vErrors;return errors === 0;}exports.validateScheduleResponse422Response = validate84;const schema47 = {"type":"string","description":"First virtual device ID.","x-standalone":false,"x-name":"scheduleResponse422Response","x-location":"#/paths//schedule/post/responses/422/content/application/json/schema_response","x-schema-type":"response"};function validate84(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate84.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema47.type,parentSchema:schema47,data}];return false;}validate84.errors = vErrors;return errors === 0;}exports.validateScheduleResponse500Request = validate85;const schema48 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"scheduleResponse500Request","x-location":"#/paths//schedule/post/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate85(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate85.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema48.type,parentSchema:schema48,data}];return false;}validate85.errors = vErrors;return errors === 0;}exports.validateScheduleResponse500Response = validate86;const schema49 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"scheduleResponse500Response","x-location":"#/paths//schedule/post/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate86(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate86.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema49.type,parentSchema:schema49,data}];return false;}validate86.errors = vErrors;return errors === 0;}exports.validateNewBookingBodyRequest = validate87;const schema50 = {"type":"object","required":["Devices","Time"],"properties":{"Devices":{"type":"array","description":"List of devices which should be added.","items":{"$ref":"#/components/schemas/Device_request"}},"Time":{"$ref":"#/components/schemas/Timeslot_request"},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]}},"x-standalone":false,"x-name":"newBookingBodyRequest","x-location":"#/paths//booking/post/requestBody/content/application/json/schema_request","x-schema-type":"request"};function validate87(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Devices === undefined) && (missing0 = "Devices")) || ((data.Time === undefined) && (missing0 = "Time"))){validate87.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema50.required,parentSchema:schema50,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate61(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate61.errors : vErrors.concat(validate61.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate87.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema50.properties.Devices.type,parentSchema:schema50.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs4 = errors;if(!(validate56(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate56.errors : vErrors.concat(validate56.errors);errors = vErrors.length;}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data3 = data.Type;const _errs5 = errors;if(typeof data3 !== "string"){validate87.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema50.properties.Type.type,parentSchema:schema50.properties.Type,data:data3}];return false;}if(!(data3 === "normal")){validate87.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema50.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema50.properties.Type.enum,parentSchema:schema50.properties.Type,data:data3}];return false;}var valid0 = _errs5 === errors;}else {var valid0 = true;}}}}}else {validate87.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema50.type,parentSchema:schema50,data}];return false;}}validate87.errors = vErrors;return errors === 0;}exports.validateNewBookingBodyResponse = validate90;const schema51 = {"type":"object","required":["Devices","Time"],"properties":{"Devices":{"type":"array","description":"List of devices which should be added.","items":{"$ref":"#/components/schemas/Device_response"}},"Time":{"$ref":"#/components/schemas/Timeslot_response"},"Type":{"description":"Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.","type":"string","enum":["normal"]}},"x-standalone":false,"x-name":"newBookingBodyResponse","x-location":"#/paths//booking/post/requestBody/content/application/json/schema_response","x-schema-type":"response"};function validate90(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Devices === undefined) && (missing0 = "Devices")) || ((data.Time === undefined) && (missing0 = "Time"))){validate90.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema51.required,parentSchema:schema51,data}];return false;}else {if(data.Devices !== undefined){let data0 = data.Devices;const _errs1 = errors;if(errors === _errs1){if(Array.isArray(data0)){var valid1 = true;const len0 = data0.length;for(let i0=0; i0<len0; i0++){const _errs3 = errors;if(!(validate62(data0[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data0,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate62.errors : vErrors.concat(validate62.errors);errors = vErrors.length;}var valid1 = _errs3 === errors;if(!valid1){break;}}}else {validate90.errors = [{instancePath:instancePath+"/Devices",schemaPath:"#/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema51.properties.Devices.type,parentSchema:schema51.properties.Devices,data:data0}];return false;}}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Time !== undefined){const _errs4 = errors;if(!(validate59(data.Time, {instancePath:instancePath+"/Time",parentData:data,parentDataProperty:"Time",rootData}))){vErrors = vErrors === null ? validate59.errors : vErrors.concat(validate59.errors);errors = vErrors.length;}var valid0 = _errs4 === errors;}else {var valid0 = true;}if(valid0){if(data.Type !== undefined){let data3 = data.Type;const _errs5 = errors;if(typeof data3 !== "string"){validate90.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema51.properties.Type.type,parentSchema:schema51.properties.Type,data:data3}];return false;}if(!(data3 === "normal")){validate90.errors = [{instancePath:instancePath+"/Type",schemaPath:"#/properties/Type/enum",keyword:"enum",params:{allowedValues: schema51.properties.Type.enum},message:"must be equal to one of the allowed values",schema:schema51.properties.Type.enum,parentSchema:schema51.properties.Type,data:data3}];return false;}var valid0 = _errs5 === errors;}else {var valid0 = true;}}}}}else {validate90.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema51.type,parentSchema:schema51,data}];return false;}}validate90.errors = vErrors;return errors === 0;}exports.validateNewBookingResponse200Request = validate93;const schema52 = {"type":"object","required":["BookingID"],"properties":{"BookingID":{"type":"string","format":"uri","description":"ID at which the booking can be managed."}},"x-standalone":false,"x-name":"newBookingResponse200Request","x-location":"#/paths//booking/post/responses/200/content/application/json/schema_request","x-schema-type":"request"};function validate93(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.BookingID === undefined) && (missing0 = "BookingID")){validate93.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema52.required,parentSchema:schema52,data}];return false;}else {if(data.BookingID !== undefined){let data0 = data.BookingID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate93.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema52.properties.BookingID,data:data0}];return false;}}else {validate93.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema52.properties.BookingID.type,parentSchema:schema52.properties.BookingID,data:data0}];return false;}}}}}}else {validate93.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema52.type,parentSchema:schema52,data}];return false;}}validate93.errors = vErrors;return errors === 0;}exports.validateNewBookingResponse200Response = validate94;const schema53 = {"type":"object","required":["BookingID"],"properties":{"BookingID":{"type":"string","format":"uri","description":"ID at which the booking can be managed."}},"x-standalone":false,"x-name":"newBookingResponse200Response","x-location":"#/paths//booking/post/responses/200/content/application/json/schema_response","x-schema-type":"response"};function validate94(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.BookingID === undefined) && (missing0 = "BookingID")){validate94.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema53.required,parentSchema:schema53,data}];return false;}else {if(data.BookingID !== undefined){let data0 = data.BookingID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate94.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema53.properties.BookingID,data:data0}];return false;}}else {validate94.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema53.properties.BookingID.type,parentSchema:schema53.properties.BookingID,data:data0}];return false;}}}}}}else {validate94.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema53.type,parentSchema:schema53,data}];return false;}}validate94.errors = vErrors;return errors === 0;}exports.validateNewBookingResponse500Request = validate95;const schema54 = {"description":"Error description","type":"string","x-standalone":false,"x-name":"newBookingResponse500Request","x-location":"#/paths//booking/post/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate95(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate95.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema54.type,parentSchema:schema54,data}];return false;}validate95.errors = vErrors;return errors === 0;}exports.validateNewBookingResponse500Response = validate96;const schema55 = {"description":"Error description","type":"string","x-standalone":false,"x-name":"newBookingResponse500Response","x-location":"#/paths//booking/post/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate96(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate96.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema55.type,parentSchema:schema55,data}];return false;}validate96.errors = vErrors;return errors === 0;}exports.validateUpdateBookingBodyRequest = validate97;const schema56 = {"anyOf":[{"type":"object","description":"Use this request for adding devices.","properties":{"Locked":{"type":"boolean","description":"Expresses whether the devices should be locked. Must match current status of booking."},"Devices":{"type":"array","description":"List of devices which should be added.","items":{"$ref":"#/components/schemas/Device_request"}}}},{"type":"object","description":"Use this request for adding callbacks.","properties":{"Callback":{"type":"string","format":"uri","description":"Callback which should be called at changes."}}}],"x-standalone":false,"x-name":"updateBookingBodyRequest","x-location":"#/paths//booking/{ID}/patch/requestBody/content/application/json/schema_request","x-schema-type":"request"};function validate97(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;const _errs0 = errors;let valid0 = false;const _errs1 = errors;if(errors === _errs1){if(data && typeof data == "object" && !Array.isArray(data)){if(data.Locked !== undefined){let data0 = data.Locked;const _errs3 = errors;if(typeof data0 !== "boolean"){const err0 = {instancePath:instancePath+"/Locked",schemaPath:"#/anyOf/0/properties/Locked/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema56.anyOf[0].properties.Locked.type,parentSchema:schema56.anyOf[0].properties.Locked,data:data0};if(vErrors === null){vErrors = [err0];}else {vErrors.push(err0);}errors++;}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data.Devices !== undefined){let data1 = data.Devices;const _errs5 = errors;if(errors === _errs5){if(Array.isArray(data1)){var valid2 = true;const len0 = data1.length;for(let i0=0; i0<len0; i0++){const _errs7 = errors;if(!(validate61(data1[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data1,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate61.errors : vErrors.concat(validate61.errors);errors = vErrors.length;}var valid2 = _errs7 === errors;if(!valid2){break;}}}else {const err1 = {instancePath:instancePath+"/Devices",schemaPath:"#/anyOf/0/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema56.anyOf[0].properties.Devices.type,parentSchema:schema56.anyOf[0].properties.Devices,data:data1};if(vErrors === null){vErrors = [err1];}else {vErrors.push(err1);}errors++;}}var valid1 = _errs5 === errors;}else {var valid1 = true;}}}else {const err2 = {instancePath,schemaPath:"#/anyOf/0/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema56.anyOf[0].type,parentSchema:schema56.anyOf[0],data};if(vErrors === null){vErrors = [err2];}else {vErrors.push(err2);}errors++;}}var _valid0 = _errs1 === errors;valid0 = valid0 || _valid0;if(!valid0){const _errs8 = errors;if(errors === _errs8){if(data && typeof data == "object" && !Array.isArray(data)){if(data.Callback !== undefined){let data3 = data.Callback;const _errs10 = errors;if(errors === _errs10){if(errors === _errs10){if(typeof data3 === "string"){if(!(formats0(data3))){const err3 = {instancePath:instancePath+"/Callback",schemaPath:"#/anyOf/1/properties/Callback/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema56.anyOf[1].properties.Callback,data:data3};if(vErrors === null){vErrors = [err3];}else {vErrors.push(err3);}errors++;}}else {const err4 = {instancePath:instancePath+"/Callback",schemaPath:"#/anyOf/1/properties/Callback/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema56.anyOf[1].properties.Callback.type,parentSchema:schema56.anyOf[1].properties.Callback,data:data3};if(vErrors === null){vErrors = [err4];}else {vErrors.push(err4);}errors++;}}}}}else {const err5 = {instancePath,schemaPath:"#/anyOf/1/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema56.anyOf[1].type,parentSchema:schema56.anyOf[1],data};if(vErrors === null){vErrors = [err5];}else {vErrors.push(err5);}errors++;}}var _valid0 = _errs8 === errors;valid0 = valid0 || _valid0;}if(!valid0){const err6 = {instancePath,schemaPath:"#/anyOf",keyword:"anyOf",params:{},message:"must match a schema in anyOf",schema:schema56.anyOf,parentSchema:schema56,data};if(vErrors === null){vErrors = [err6];}else {vErrors.push(err6);}errors++;validate97.errors = vErrors;return false;}else {errors = _errs0;if(vErrors !== null){if(_errs0){vErrors.length = _errs0;}else {vErrors = null;}}}validate97.errors = vErrors;return errors === 0;}exports.validateUpdateBookingBodyResponse = validate99;const schema57 = {"anyOf":[{"type":"object","description":"Use this request for adding devices.","properties":{"Locked":{"type":"boolean","description":"Expresses whether the devices should be locked. Must match current status of booking."},"Devices":{"type":"array","description":"List of devices which should be added.","items":{"$ref":"#/components/schemas/Device_response"}}}},{"type":"object","description":"Use this request for adding callbacks.","properties":{"Callback":{"type":"string","format":"uri","description":"Callback which should be called at changes."}}}],"x-standalone":false,"x-name":"updateBookingBodyResponse","x-location":"#/paths//booking/{ID}/patch/requestBody/content/application/json/schema_response","x-schema-type":"response"};function validate99(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;const _errs0 = errors;let valid0 = false;const _errs1 = errors;if(errors === _errs1){if(data && typeof data == "object" && !Array.isArray(data)){if(data.Locked !== undefined){let data0 = data.Locked;const _errs3 = errors;if(typeof data0 !== "boolean"){const err0 = {instancePath:instancePath+"/Locked",schemaPath:"#/anyOf/0/properties/Locked/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema57.anyOf[0].properties.Locked.type,parentSchema:schema57.anyOf[0].properties.Locked,data:data0};if(vErrors === null){vErrors = [err0];}else {vErrors.push(err0);}errors++;}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data.Devices !== undefined){let data1 = data.Devices;const _errs5 = errors;if(errors === _errs5){if(Array.isArray(data1)){var valid2 = true;const len0 = data1.length;for(let i0=0; i0<len0; i0++){const _errs7 = errors;if(!(validate62(data1[i0], {instancePath:instancePath+"/Devices/" + i0,parentData:data1,parentDataProperty:i0,rootData}))){vErrors = vErrors === null ? validate62.errors : vErrors.concat(validate62.errors);errors = vErrors.length;}var valid2 = _errs7 === errors;if(!valid2){break;}}}else {const err1 = {instancePath:instancePath+"/Devices",schemaPath:"#/anyOf/0/properties/Devices/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema57.anyOf[0].properties.Devices.type,parentSchema:schema57.anyOf[0].properties.Devices,data:data1};if(vErrors === null){vErrors = [err1];}else {vErrors.push(err1);}errors++;}}var valid1 = _errs5 === errors;}else {var valid1 = true;}}}else {const err2 = {instancePath,schemaPath:"#/anyOf/0/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema57.anyOf[0].type,parentSchema:schema57.anyOf[0],data};if(vErrors === null){vErrors = [err2];}else {vErrors.push(err2);}errors++;}}var _valid0 = _errs1 === errors;valid0 = valid0 || _valid0;if(!valid0){const _errs8 = errors;if(errors === _errs8){if(data && typeof data == "object" && !Array.isArray(data)){if(data.Callback !== undefined){let data3 = data.Callback;const _errs10 = errors;if(errors === _errs10){if(errors === _errs10){if(typeof data3 === "string"){if(!(formats0(data3))){const err3 = {instancePath:instancePath+"/Callback",schemaPath:"#/anyOf/1/properties/Callback/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema57.anyOf[1].properties.Callback,data:data3};if(vErrors === null){vErrors = [err3];}else {vErrors.push(err3);}errors++;}}else {const err4 = {instancePath:instancePath+"/Callback",schemaPath:"#/anyOf/1/properties/Callback/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema57.anyOf[1].properties.Callback.type,parentSchema:schema57.anyOf[1].properties.Callback,data:data3};if(vErrors === null){vErrors = [err4];}else {vErrors.push(err4);}errors++;}}}}}else {const err5 = {instancePath,schemaPath:"#/anyOf/1/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema57.anyOf[1].type,parentSchema:schema57.anyOf[1],data};if(vErrors === null){vErrors = [err5];}else {vErrors.push(err5);}errors++;}}var _valid0 = _errs8 === errors;valid0 = valid0 || _valid0;}if(!valid0){const err6 = {instancePath,schemaPath:"#/anyOf",keyword:"anyOf",params:{},message:"must match a schema in anyOf",schema:schema57.anyOf,parentSchema:schema57,data};if(vErrors === null){vErrors = [err6];}else {vErrors.push(err6);}errors++;validate99.errors = vErrors;return false;}else {errors = _errs0;if(vErrors !== null){if(_errs0){vErrors.length = _errs0;}else {vErrors = null;}}}validate99.errors = vErrors;return errors === 0;}exports.validateUpdateBookingResponse200Request = validate101;const schema58 = {"type":"object","required":["BookingID"],"properties":{"BookingID":{"type":"string","format":"uri"}},"x-standalone":false,"x-name":"updateBookingResponse200Request","x-location":"#/paths//booking/{ID}/patch/responses/200/content/application/json/schema_request","x-schema-type":"request"};function validate101(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.BookingID === undefined) && (missing0 = "BookingID")){validate101.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema58.required,parentSchema:schema58,data}];return false;}else {if(data.BookingID !== undefined){let data0 = data.BookingID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate101.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema58.properties.BookingID,data:data0}];return false;}}else {validate101.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema58.properties.BookingID.type,parentSchema:schema58.properties.BookingID,data:data0}];return false;}}}}}}else {validate101.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema58.type,parentSchema:schema58,data}];return false;}}validate101.errors = vErrors;return errors === 0;}exports.validateUpdateBookingResponse200Response = validate102;const schema59 = {"type":"object","required":["BookingID"],"properties":{"BookingID":{"type":"string","format":"uri"}},"x-standalone":false,"x-name":"updateBookingResponse200Response","x-location":"#/paths//booking/{ID}/patch/responses/200/content/application/json/schema_response","x-schema-type":"response"};function validate102(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if((data.BookingID === undefined) && (missing0 = "BookingID")){validate102.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema59.required,parentSchema:schema59,data}];return false;}else {if(data.BookingID !== undefined){let data0 = data.BookingID;const _errs1 = errors;if(errors === _errs1){if(errors === _errs1){if(typeof data0 === "string"){if(!(formats0(data0))){validate102.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema59.properties.BookingID,data:data0}];return false;}}else {validate102.errors = [{instancePath:instancePath+"/BookingID",schemaPath:"#/properties/BookingID/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema59.properties.BookingID.type,parentSchema:schema59.properties.BookingID,data:data0}];return false;}}}}}}else {validate102.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema59.type,parentSchema:schema59,data}];return false;}}validate102.errors = vErrors;return errors === 0;}exports.validateUpdateBookingResponse500Request = validate103;const schema60 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"updateBookingResponse500Request","x-location":"#/paths//booking/{ID}/patch/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate103(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate103.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema60.type,parentSchema:schema60,data}];return false;}validate103.errors = vErrors;return errors === 0;}exports.validateUpdateBookingResponse500Response = validate104;const schema61 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"updateBookingResponse500Response","x-location":"#/paths//booking/{ID}/patch/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate104(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate104.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema61.type,parentSchema:schema61,data}];return false;}validate104.errors = vErrors;return errors === 0;}exports.validateDeleteBookingResponse500Request = validate105;const schema62 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"deleteBookingResponse500Request","x-location":"#/paths//booking/{ID}/delete/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate105(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate105.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema62.type,parentSchema:schema62,data}];return false;}validate105.errors = vErrors;return errors === 0;}exports.validateDeleteBookingResponse500Response = validate106;const schema63 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"deleteBookingResponse500Response","x-location":"#/paths//booking/{ID}/delete/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate106(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate106.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema63.type,parentSchema:schema63,data}];return false;}validate106.errors = vErrors;return errors === 0;}exports.validateGetBookingResponse200Request = validate107;const schema64 = {"type":"object","required":["Booking","Locked"],"properties":{"Booking":{"$ref":"#/components/schemas/Booking_request"},"Locked":{"type":"boolean","description":"Shows if the booking is in a locked status."}},"x-standalone":false,"x-name":"getBookingResponse200Request","x-location":"#/paths//booking/{ID}/get/responses/200/content/application/json/schema_request","x-schema-type":"request"};function validate107(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Booking === undefined) && (missing0 = "Booking")) || ((data.Locked === undefined) && (missing0 = "Locked"))){validate107.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema64.required,parentSchema:schema64,data}];return false;}else {if(data.Booking !== undefined){const _errs1 = errors;if(!(validate55(data.Booking, {instancePath:instancePath+"/Booking",parentData:data,parentDataProperty:"Booking",rootData}))){vErrors = vErrors === null ? validate55.errors : vErrors.concat(validate55.errors);errors = vErrors.length;}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Locked !== undefined){let data1 = data.Locked;const _errs2 = errors;if(typeof data1 !== "boolean"){validate107.errors = [{instancePath:instancePath+"/Locked",schemaPath:"#/properties/Locked/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema64.properties.Locked.type,parentSchema:schema64.properties.Locked,data:data1}];return false;}var valid0 = _errs2 === errors;}else {var valid0 = true;}}}}else {validate107.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema64.type,parentSchema:schema64,data}];return false;}}validate107.errors = vErrors;return errors === 0;}exports.validateGetBookingResponse200Response = validate109;const schema65 = {"type":"object","required":["Booking","Locked"],"properties":{"Booking":{"$ref":"#/components/schemas/Booking_response"},"Locked":{"type":"boolean","description":"Shows if the booking is in a locked status."}},"x-standalone":false,"x-name":"getBookingResponse200Response","x-location":"#/paths//booking/{ID}/get/responses/200/content/application/json/schema_response","x-schema-type":"response"};function validate109(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(data && typeof data == "object" && !Array.isArray(data)){let missing0;if(((data.Booking === undefined) && (missing0 = "Booking")) || ((data.Locked === undefined) && (missing0 = "Locked"))){validate109.errors = [{instancePath,schemaPath:"#/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema65.required,parentSchema:schema65,data}];return false;}else {if(data.Booking !== undefined){const _errs1 = errors;if(!(validate58(data.Booking, {instancePath:instancePath+"/Booking",parentData:data,parentDataProperty:"Booking",rootData}))){vErrors = vErrors === null ? validate58.errors : vErrors.concat(validate58.errors);errors = vErrors.length;}var valid0 = _errs1 === errors;}else {var valid0 = true;}if(valid0){if(data.Locked !== undefined){let data1 = data.Locked;const _errs2 = errors;if(typeof data1 !== "boolean"){validate109.errors = [{instancePath:instancePath+"/Locked",schemaPath:"#/properties/Locked/type",keyword:"type",params:{type: "boolean"},message:"must be boolean",schema:schema65.properties.Locked.type,parentSchema:schema65.properties.Locked,data:data1}];return false;}var valid0 = _errs2 === errors;}else {var valid0 = true;}}}}else {validate109.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema65.type,parentSchema:schema65,data}];return false;}}validate109.errors = vErrors;return errors === 0;}exports.validateGetBookingResponse500Request = validate111;const schema66 = {"type":"string","description":"Error code","x-standalone":false,"x-name":"getBookingResponse500Request","x-location":"#/paths//booking/{ID}/get/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate111(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate111.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema66.type,parentSchema:schema66,data}];return false;}validate111.errors = vErrors;return errors === 0;}exports.validateGetBookingResponse500Response = validate112;const schema67 = {"type":"string","description":"Error code","x-standalone":false,"x-name":"getBookingResponse500Response","x-location":"#/paths//booking/{ID}/get/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate112(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate112.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema67.type,parentSchema:schema67,data}];return false;}validate112.errors = vErrors;return errors === 0;}exports.validateDestroyBookingResponse500Request = validate113;const schema68 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"destroyBookingResponse500Request","x-location":"#/paths//booking/{ID}/destroy/delete/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate113(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate113.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema68.type,parentSchema:schema68,data}];return false;}validate113.errors = vErrors;return errors === 0;}exports.validateDestroyBookingResponse500Response = validate114;const schema69 = {"type":"string","description":"Error description","x-standalone":false,"x-name":"destroyBookingResponse500Response","x-location":"#/paths//booking/{ID}/destroy/delete/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate114(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate114.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema69.type,parentSchema:schema69,data}];return false;}validate114.errors = vErrors;return errors === 0;}exports.validateLockBookingResponse200Request = validate115;const schema70 = {"type":"array","description":"The list of booked devices and selected real devices. Order is guaranteed to be the same as in the booking.","items":{"type":"object","required":["Requested","Selected"],"properties":{"Requested":{"type":"string","format":"uri"},"Selected":{"type":"string","format":"uri"}}},"x-standalone":false,"x-name":"lockBookingResponse200Request","x-location":"#/paths//booking/{ID}/lock/put/responses/200/content/application/json/schema_request","x-schema-type":"request"};function validate115(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(Array.isArray(data)){var valid0 = true;const len0 = data.length;for(let i0=0; i0<len0; i0++){let data0 = data[i0];const _errs1 = errors;if(errors === _errs1){if(data0 && typeof data0 == "object" && !Array.isArray(data0)){let missing0;if(((data0.Requested === undefined) && (missing0 = "Requested")) || ((data0.Selected === undefined) && (missing0 = "Selected"))){validate115.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema70.items.required,parentSchema:schema70.items,data:data0}];return false;}else {if(data0.Requested !== undefined){let data1 = data0.Requested;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats0(data1))){validate115.errors = [{instancePath:instancePath+"/" + i0+"/Requested",schemaPath:"#/items/properties/Requested/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema70.items.properties.Requested,data:data1}];return false;}}else {validate115.errors = [{instancePath:instancePath+"/" + i0+"/Requested",schemaPath:"#/items/properties/Requested/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema70.items.properties.Requested.type,parentSchema:schema70.items.properties.Requested,data:data1}];return false;}}}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data0.Selected !== undefined){let data2 = data0.Selected;const _errs5 = errors;if(errors === _errs5){if(errors === _errs5){if(typeof data2 === "string"){if(!(formats0(data2))){validate115.errors = [{instancePath:instancePath+"/" + i0+"/Selected",schemaPath:"#/items/properties/Selected/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema70.items.properties.Selected,data:data2}];return false;}}else {validate115.errors = [{instancePath:instancePath+"/" + i0+"/Selected",schemaPath:"#/items/properties/Selected/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema70.items.properties.Selected.type,parentSchema:schema70.items.properties.Selected,data:data2}];return false;}}}var valid1 = _errs5 === errors;}else {var valid1 = true;}}}}else {validate115.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema70.items.type,parentSchema:schema70.items,data:data0}];return false;}}var valid0 = _errs1 === errors;if(!valid0){break;}}}else {validate115.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema70.type,parentSchema:schema70,data}];return false;}}validate115.errors = vErrors;return errors === 0;}exports.validateLockBookingResponse200Response = validate116;const schema71 = {"type":"array","description":"The list of booked devices and selected real devices. Order is guaranteed to be the same as in the booking.","items":{"type":"object","required":["Requested","Selected"],"properties":{"Requested":{"type":"string","format":"uri"},"Selected":{"type":"string","format":"uri"}}},"x-standalone":false,"x-name":"lockBookingResponse200Response","x-location":"#/paths//booking/{ID}/lock/put/responses/200/content/application/json/schema_response","x-schema-type":"response"};function validate116(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(errors === 0){if(Array.isArray(data)){var valid0 = true;const len0 = data.length;for(let i0=0; i0<len0; i0++){let data0 = data[i0];const _errs1 = errors;if(errors === _errs1){if(data0 && typeof data0 == "object" && !Array.isArray(data0)){let missing0;if(((data0.Requested === undefined) && (missing0 = "Requested")) || ((data0.Selected === undefined) && (missing0 = "Selected"))){validate116.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/required",keyword:"required",params:{missingProperty: missing0},message:"must have required property '"+missing0+"'",schema:schema71.items.required,parentSchema:schema71.items,data:data0}];return false;}else {if(data0.Requested !== undefined){let data1 = data0.Requested;const _errs3 = errors;if(errors === _errs3){if(errors === _errs3){if(typeof data1 === "string"){if(!(formats0(data1))){validate116.errors = [{instancePath:instancePath+"/" + i0+"/Requested",schemaPath:"#/items/properties/Requested/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema71.items.properties.Requested,data:data1}];return false;}}else {validate116.errors = [{instancePath:instancePath+"/" + i0+"/Requested",schemaPath:"#/items/properties/Requested/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema71.items.properties.Requested.type,parentSchema:schema71.items.properties.Requested,data:data1}];return false;}}}var valid1 = _errs3 === errors;}else {var valid1 = true;}if(valid1){if(data0.Selected !== undefined){let data2 = data0.Selected;const _errs5 = errors;if(errors === _errs5){if(errors === _errs5){if(typeof data2 === "string"){if(!(formats0(data2))){validate116.errors = [{instancePath:instancePath+"/" + i0+"/Selected",schemaPath:"#/items/properties/Selected/format",keyword:"format",params:{format: "uri"},message:"must match format \""+"uri"+"\"",schema:"uri",parentSchema:schema71.items.properties.Selected,data:data2}];return false;}}else {validate116.errors = [{instancePath:instancePath+"/" + i0+"/Selected",schemaPath:"#/items/properties/Selected/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema71.items.properties.Selected.type,parentSchema:schema71.items.properties.Selected,data:data2}];return false;}}}var valid1 = _errs5 === errors;}else {var valid1 = true;}}}}else {validate116.errors = [{instancePath:instancePath+"/" + i0,schemaPath:"#/items/type",keyword:"type",params:{type: "object"},message:"must be object",schema:schema71.items.type,parentSchema:schema71.items,data:data0}];return false;}}var valid0 = _errs1 === errors;if(!valid0){break;}}}else {validate116.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "array"},message:"must be array",schema:schema71.type,parentSchema:schema71,data}];return false;}}validate116.errors = vErrors;return errors === 0;}exports.validateLockBookingResponse500Request = validate117;const schema72 = {"type":"string","description":"Error string","x-standalone":false,"x-name":"lockBookingResponse500Request","x-location":"#/paths//booking/{ID}/lock/put/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate117(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate117.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema72.type,parentSchema:schema72,data}];return false;}validate117.errors = vErrors;return errors === 0;}exports.validateLockBookingResponse500Response = validate118;const schema73 = {"type":"string","description":"Error string","x-standalone":false,"x-name":"lockBookingResponse500Response","x-location":"#/paths//booking/{ID}/lock/put/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate118(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate118.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema73.type,parentSchema:schema73,data}];return false;}validate118.errors = vErrors;return errors === 0;}exports.validateUnlockBookingResponse500Request = validate119;const schema74 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"unlockBookingResponse500Request","x-location":"#/paths//booking/{ID}/lock/delete/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate119(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate119.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema74.type,parentSchema:schema74,data}];return false;}validate119.errors = vErrors;return errors === 0;}exports.validateUnlockBookingResponse500Response = validate120;const schema75 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"unlockBookingResponse500Response","x-location":"#/paths//booking/{ID}/lock/delete/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate120(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate120.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema75.type,parentSchema:schema75,data}];return false;}validate120.errors = vErrors;return errors === 0;}exports.validateBookingCallbackResponse500Request = validate121;const schema76 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"bookingCallbackResponse500Request","x-location":"#/paths//booking_callback/{ID}/post/responses/500/content/application/json/schema_request","x-schema-type":"request"};function validate121(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate121.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema76.type,parentSchema:schema76,data}];return false;}validate121.errors = vErrors;return errors === 0;}exports.validateBookingCallbackResponse500Response = validate122;const schema77 = {"type":"string","description":"Error description.","x-standalone":false,"x-name":"bookingCallbackResponse500Response","x-location":"#/paths//booking_callback/{ID}/post/responses/500/content/application/json/schema_response","x-schema-type":"response"};function validate122(data, {instancePath="", parentData, parentDataProperty, rootData=data}={}){let vErrors = null;let errors = 0;if(typeof data !== "string"){validate122.errors = [{instancePath,schemaPath:"#/type",keyword:"type",params:{type: "string"},message:"must be string",schema:schema77.type,parentSchema:schema77,data}];return false;}validate122.errors = vErrors;return errors === 0;}